#ifndef MERCURY_KERNEL_BD_MEMORY_HPP
#define MERCURY_KERNEL_BD_MEMORY_HPP

#include <mercury/kernel/storage.hpp>

namespace mercury::kernel::bd {

  class memory : public storage::block_device {

  private:
    uint8_t *buffer;

  public:
    memory(void *buffer, size_t buffer_len);

    storage::io_result read_blocks_no_cache(uint64_t start, uint64_t count, void *into) override;
    storage::io_result write_blocks_no_cache(uint64_t start, uint64_t count, const void *from) override;

  };

}

#endif
